"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var common_1 = require('@angular/common');
var core_2 = require('../../core');
var bootstrap_select_1 = require('../bootstrap-select');
var noop = function () { };
var BOOTSTRAP_CONTROL_VALUE_ACCESSOR = new core_1.Provider(common_1.NG_VALUE_ACCESSOR, {
    useExisting: core_1.forwardRef(function () { return BootstrapMultiSelectComponent; }),
    multi: true
});
var BootstrapMultiSelectComponent = (function (_super) {
    __extends(BootstrapMultiSelectComponent, _super);
    function BootstrapMultiSelectComponent() {
        _super.call(this);
    }
    BootstrapMultiSelectComponent.prototype.ngOnInit = function () {
    };
    BootstrapMultiSelectComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.options.changes.subscribe(function (options) { return options.forEach(function (option) {
            if (_this.ngModel && _this.ngModel.length)
                _this.syncNgModelMultiselect(_this.ngModel);
            option.click.subscribe(function (o) { return _this.toggleNgModelMultiselect(o); });
        }); });
    };
    BootstrapMultiSelectComponent.prototype.ngAfterViewInit = function () {
        //console.log('#builder', this.builder);
    };
    BootstrapMultiSelectComponent.prototype.onBlur = function ($event) {
        //console.log('blur => this.options', this.options);
    };
    // ngOnChanges(changes: {[key: string]: SimpleChange;}){
    //     let ngModelChange = changes['ngModel'];
    //     if(ngModelChange && !ngModelChange.isFirstChange()){
    //         this.onChange(this.options.filter(o => o.value == ngModelChange.currentValue)[0])
    //     }
    // }
    // onChange(option: IxOptionComponent) {
    //     if (!option || !option.elem)
    //         return;
    //     return this.setNgModelMultiselect(option);
    // }
    BootstrapMultiSelectComponent.prototype.selectAll = function () {
        /* Set all options as active using the observable list */
        this.options.forEach(function (o) { return o.active = true; });
        var activeOptions = this.options.filter(function (o) { return o.active; });
        var newVals = activeOptions.map(function (o) { return o.value; });
        this.onNgModelChanged(newVals);
        this.change.emit(newVals);
        this.setTitleMultiselect(activeOptions);
    };
    BootstrapMultiSelectComponent.prototype.unselectAll = function () {
        /* Set all options as inactive using the observable list */
        this.options.forEach(function (o) { return o.active = false; });
        var activeOptions = this.options.filter(function (o) { return o.active; });
        var newVals = activeOptions.map(function (o) { return o.value; });
        this.onNgModelChanged(newVals);
        this.change.emit(newVals);
        this.setTitleMultiselect(activeOptions);
    };
    BootstrapMultiSelectComponent.prototype.setTitleMultiselect = function (activeOptions) {
        if (!activeOptions.length)
            return this.title = '<-- select -->';
        if (activeOptions.length <= 2)
            return this.title = activeOptions.map(function (o) { return o.title; }).join(', ');
        return this.title = activeOptions.length + " selected";
        //let newVals: any[] = this.options.filter(o => o.active === true).flatMap(project: (value: IxOptionComponent, index: number) => Subscribable<I> | Promise<I> | ArrayLike<I>, resultSelector: (outerValue: IxOptionComponent, innerValue: I, outerIndex: number, innerIndex: number) => R, concurrent?: number).toArray();
        //this.title = newVals.join(',');
    };
    BootstrapMultiSelectComponent.prototype.syncNgModelMultiselect = function (newVals) {
        this.options.forEach(function (o) { return o.active = false; });
        var activeOptions = this.options.filter(function (o) { return newVals.indexOf(o.value) > -1; });
        activeOptions.forEach(function (o) { return o.active = true; });
        this.setTitleMultiselect(activeOptions);
    };
    BootstrapMultiSelectComponent.prototype.toggleNgModelMultiselect = function (option) {
        /* Toogle the clicked option's active property using the observable list */
        this.options.filter(function (o) { return o.value == option.value; }).forEach(function (o) { return o.active = !o.active; });
        var activeOptions = this.options.filter(function (o) { return o.active; });
        var newVals = activeOptions.map(function (o) { return o.value; });
        this.onNgModelChanged(newVals);
        this.change.emit(newVals);
        this.setTitleMultiselect(activeOptions);
    };
    /* Override writeValue() from ControlValueAccessor */
    BootstrapMultiSelectComponent.prototype.writeValue = function (newVals) {
        _super.prototype.writeValue.call(this, newVals);
        if (this.options)
            this.syncNgModelMultiselect(newVals);
    };
    BootstrapMultiSelectComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'ix-bootstrap-select[multiple]',
            templateUrl: 'bootstrap-multi-select.component.html',
            styleUrls: ['bootstrap-multi-select.component.css'],
            directives: [common_1.COMMON_DIRECTIVES, core_2.IX_DIRECTIVES],
            pipes: [common_1.COMMON_PIPES],
            providers: [BOOTSTRAP_CONTROL_VALUE_ACCESSOR]
        }), 
        __metadata('design:paramtypes', [])
    ], BootstrapMultiSelectComponent);
    return BootstrapMultiSelectComponent;
}(bootstrap_select_1.BootstrapSelect));
exports.BootstrapMultiSelectComponent = BootstrapMultiSelectComponent;
//# sourceMappingURL=bootstrap-multi-select.component.js.map